JSB.newAddon = function (mainPath) {
    return JSB.defineClass('AutoMultiTitle : JSExtension', /*Instance members*/{
        //Window initialize
        sceneWillConnect: function () {
            self.webController = WebViewController.new();
        },
        //Window disconnect
        sceneDidDisconnect: function () {
        },
        //Window resign active
        sceneWillResignActive: function () {
        },
        //Window become active
        sceneDidBecomeActive: function () {
        },
        notebookWillOpen: function (notebookid) {
            NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
            self.automultititle = NSUserDefaults.standardUserDefaults().objectForKey('marginnote.extension.automultititle');
            self.autotitle = NSUserDefaults.standardUserDefaults().objectForKey('marginnote.extension.autotitle');
            self.autotitle_with_excerpt = NSUserDefaults.standardUserDefaults().objectForKey('marginnote.extension.autotitle_with_excerpt');
        },
        notebookWillClose: function (notebookid) {
            NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnNote');
        },
        documentDidOpen: function (docmd5) {
        },
        documentWillClose: function (docmd5) {
        },
        controllerWillLayoutSubviews: function (controller) {
        },
        queryAddonCommandStatus: function () {
            if (Application.sharedInstance().studyController(self.window).studyMode < 3)
                return {
                    image: 'title.png',
                    object: self,
                    selector: 'toggleAutoMultiTitle:',
                    checked: (self.automultititle),
                };
            return null;
        },
        //Clicking note
        onPopupMenuOnNote: function (sender) {
            if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window)) return;//Don't process message from other window
            if (!self.automultititle) return;

            let note = sender.userInfo.note;

            let children = note.childNotes;
            let c_len = 0;


            if (note && children && children.length > 0) {
                c_len = children.length;
                // 编号起始值, 填写在零时节点的摘录内容中
                // 不可以使用 note.excerptText ,因为是从脑图中直接创建的临时节点，无法得到摘录内容
                // let begin_number = note.excerptText;
                let first_comment = note.comments[0];
                let begin_number = 1;
                let reg = /^[0-9]*$/;

                if (first_comment) {
                    begin_number = first_comment.text;
                }

                if (!first_comment || !reg.test(begin_number)) {

                    // 如果没有设置起始编号，或者设置的内容不是数字
                    // 自动将其设置为1
                    begin_number = 1;
                }

                // 标题模板。例如: 例题1.13.@
                // 插件自动把 @ 替换成，seq_number
                let module_title = note.noteTitle;
                // 只能出现一次 '@' 占位符
                let title_reg = /^[^@]*[@]{1}[^@]*$/;
                if (!title_reg.test(module_title)) {
                    Application.sharedInstance().showHUD('占位符:@ , 只能出现一次', self.window, 3);
                    return;
                }


                let timerCount = 0;
                NSTimer.scheduledTimerWithTimeInterval(1, true, function (timer) {
                    UndoManager.sharedInstance().undoGrouping('AutoMultiTitle', note.notebookId, function () {
                        let seq_number = begin_number;

                        for (var i = 0; i < c_len; i++) {

                            // 如果检查到这个模板 已经被添加到子节点的标题中，就替换子节点的当前的标题，而不是继续向前追加
                            let reg_str = "^".concat(module_title.replace('@', '[0-9]+'));
                            let reg_title_chk = new RegExp(reg_str);
                            let org_title = children[i].noteTitle;
                            if (!org_title){
                                children[i].noteTitle = module_title.replace('@', seq_number).concat(' ')
                            }else{
                                if (reg_title_chk.test(children[i].noteTitle)) {
                                    let pre_title = module_title.replace('@', seq_number);
                                    children[i].noteTitle = children[i].noteTitle.replace(reg_title_chk, pre_title)
                                } else {
                                    children[i].noteTitle = module_title.replace('@', seq_number).concat(' ', children[i].noteTitle);
                                }
                            }


                            seq_number++;
                        }

                        Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
                    });
                    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange', self, {topicid: note.notebookId});

                    timerCount++;
                    if (timerCount >= 1) {
                        timer.invalidate();
                    }
                });
            }

        },
        toggleAutoMultiTitle: function (sender) {
            let lan = NSLocale.preferredLanguages().length ? NSLocale.preferredLanguages()[0].substring(0, 2) : 'en';
            if (self.automultititle) {
                self.automultititle = false;
                let cnTips = '批量标题设置 已关闭';
                let enTips = 'Auto title is turned off';
                Application.sharedInstance().showHUD(lan === 'zh' ? cnTips : enTips, self.window, 2);
            } else {
                self.automultititle = true;
                let cnTips = '点击父节点，批量设置标题';
                let enTips = 'After clicking a card, the excerpt and title will be toggled';
                if (self.autotitle || self.autotitle_with_excerpt) {
                    // todo: invalid
                    self.autotitle = false;
                    self.autotitle_with_excerpt = false;
                    cnTips = '请确保其他标题插件已关闭';
                    enTips = 'Make sure that Other Title Plugin has been closed';
                }
                Application.sharedInstance().showHUD(lan === 'zh' ? cnTips : enTips, self.window, 2);
            }
            NSUserDefaults.standardUserDefaults().setObjectForKey(self.automultititle, 'marginnote_automultititle');
            Application.sharedInstance().studyController(self.window).refreshAddonCommands();
        },
    }, /*Class members*/{
        addonDidConnect: function () {
        },
        addonWillDisconnect: function () {
        },
        applicationWillEnterForeground: function () {
        },
        applicationDidEnterBackground: function () {
        },
        applicationDidReceiveLocalNotification: function (notify) {
        },
    });
};

